/*
 * lease.h
 *
 * Copyright (C) 2009  Red Hat, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author(s): David Cantrell <dcantrell@redhat.com>
 */

/*
 * Copyright (C) International Business Machines  Corp., 2003
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/* Author: Shirley Ma, xma@us.ibm.com */

#ifndef __LEASE_H_DEFINED
#define __LEASE_H_DEFINED

#include "constants.h"
#include "types.h"
#include "str.h"

/* XXX: defined in both client6_token.l and server6_token.l */
extern const gchar *configfilename;

/* XXX: defined in client6_parse.y */
extern cf_list_t *cf_dns_list;

/* XXX: this is a global that needs to be removed */
extern const dhcp6_mode_t dhcp6_mode;

/* XXX: from lease_token.l */
extern void lease_parse(FILE *);

gint write_lease(const dhcp6_lease_t *, FILE *);
FILE *sync_leases(FILE *, const gchar *);
dhcp6_timer_t *syncfile_timo(void *);
FILE *init_leases(const gchar *);
gint prefixcmp(struct in6_addr *, struct in6_addr *, gint);
gint get_linklocal(const gchar *, struct in6_addr *);
gint dhcp6_get_prefixlen(struct in6_addr *, dhcp6_if_t *);
gint addr_on_addrlist(GSList *, dhcp6_addr_t *);
guint32 get_min_preferlifetime(dhcp6_iaidaddr_t *);
guint32 get_max_validlifetime(dhcp6_iaidaddr_t *);
dhcp6_lease_t *dhcp6_find_lease(dhcp6_iaidaddr_t *, dhcp6_addr_t *);

#endif /* __LEASE_H_DEFINED */
